#ifdef _WIN32
#define WIN32NATIVE
#endif

#include <windows.h>
#include <io.h>
#include <wincon.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <errno.h>
#include <fcntl.h>

typedef unsigned char uint8_t;
typedef unsigned short uint16_t;
typedef unsigned int uint32_t;

#define PSTR(str)	(str)
#define __LPM(p)	(*p)
#define strcmp_P	strcmp
#define strcpy_P	strcpy

static HANDLE conin;
static DWORD conin_mode_sv;

void lin_term() {
	if (conin_mode_sv != 0) 
		SetConsoleMode(conin, conin_mode_sv);
}

void lin_init() {
	DWORD conin_mode = 0;
	int r;

	conin = GetStdHandle(STD_INPUT_HANDLE);
	r = GetConsoleMode(conin, &conin_mode);
	if (r) {
		conin_mode_sv = conin_mode;
		conin_mode &= ~(ENABLE_LINE_INPUT | ENABLE_ECHO_INPUT);
		r = SetConsoleMode(conin, conin_mode);
		fprintf(stderr, "using stdin as a console\n");
		fprintf(stderr, "conin 0x%08x  %08x -> %08x\n",
				conin, conin_mode_sv, conin_mode);
		fflush(stderr);

	} else {
		CONSOLE_SCREEN_BUFFER_INFO info;
		r = GetConsoleScreenBufferInfo(GetStdHandle(STD_INPUT_HANDLE),&info);
		fprintf(stderr, "csb info (INPUT) %d\n",r);
		r = GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE),&info);
		fprintf(stderr, "csb info (OUTPUT) %d\n",r);
		r = GetConsoleScreenBufferInfo(GetStdHandle(STD_ERROR_HANDLE),&info);
		fprintf(stderr, "csb info (ERROR) %d\n",r);
		conin = CreateFile("CONIN$", GENERIC_READ|GENERIC_WRITE,
			FILE_SHARE_READ|FILE_SHARE_WRITE, 
			(LPSECURITY_ATTRIBUTES)NULL,
			OPEN_EXISTING, 0 , (HANDLE)NULL);
		fprintf(stderr, "create handle %08x\n",conin);
		r = SetConsoleActiveScreenBuffer(conin);
		fprintf(stderr, "create handle %08x act %d\n",conin,r);
		r = GetConsoleMode(conin, &conin_mode);
		fprintf(stderr, "conin_mode %08x %d\n",conin_mode,r);
		conin_mode &= ~(ENABLE_LINE_INPUT | ENABLE_ECHO_INPUT);
		fprintf(stderr, "        -> %08x %d\n",conin_mode,r);

		fflush(stderr);
	}
}

void usbcdc_putc(char data) {
	write(1, &data, 1);
}

char usbcdc_getc(void) {
	char buf[3];
	DWORD nrec = 0;

	while (!ReadConsole(conin, buf, 1, &nrec, NULL) || nrec == 0)
			;
	return buf[0];
}

main() {
	int ch;
	lin_init();
	for (;;) {
		ch = usbcdc_getc();
		usbcdc_putc(ch);
		if (ch == '\r') {
			usbcdc_putc('\n');
		} else if (ch == '\b') {
			usbcdc_putc(' ');
			usbcdc_putc(ch);
		}
	}
}
